<?php
//*************************************************************
//
// Entree dans le service de CHAT
//
//  Traduction : Ok
//
// Projet      : Chaton
// Version     : 1.6.2
// Date        : 9 novembre 2006
//
//*************************************************************

    // Inclus
    require_once( "inc/chat.php");
    require_once( "inc/securite.php");
    require_once( "inc/session.php");
    require_once( "inc/externe.php");
    require_once( "inc/database.php");
    require_once( "inc/log.php");
    require_once( "inc/users.php");
    require_once( "inc/salons.php");
    require_once( "inc/nocache.php");
    require_once( "inc/langue.php");
    require_once( "inc/interdit.php");
    require_once( "inc/cryptage.php");
    require_once( "inc/html.php");
    require_once( "inc/email.php");
    require_once( "inc/meta.php");
    require_once( "inc/browser_detection.php");
    // Scurit des variables d'environnement
    require_once( "inc/env.php");

    function PageErreur( $parametres) {
        Global $url_erreur;

        if (strpos( $url_erreur, '?') === false) {
            $url_erreur .= '?';
        } else {
            $url_erreur .= '&';
        }
        return( $url_erreur . $parametres);
    }

    // Retour des fonctions de base utilisateurs externe
    define( "EXT_UTILISATEUR_INCONNU",     -1);
    define( "EXT_ERREUR_AUTHENTIFICATION", -2);

    $newpriv = PRIV_SANS_ACCES;
    $flags = 0;

    // Cookie SPIP ?
    if (isset($_COOKIE['spip_session'])) $spip_session = $_COOKIE['spip_session'];

    chat_open();

    // Charge le module de langue associ au script courant
    if (file_exists( "lang/$lang/entree.php")) {
        include( "lang/$lang/entree.php");
    }

    // Type de navigateur utilis
    $navigateur = browser_detection('full');
    if ($navigateur[0] == 'op') {
        $flags = $flags + FLAG_REFRESH_USER;
    }

    if (( isset( $creersalon)) and ($creersalon <> '') ) {
        // Nouveau salon !
        $newsalon = $creersalon;
    }

    // Salon par dfaut
    if (!defined( "AUTORISER_PLUSIEURS_SALONS") or (AUTORISER_PLUSIEURS_SALONS == false)) {
        $newsalon = 'defaut';
    }

    // Valide les entres login et salon
    $newlogin = ValideNom( $newlogin);
    $newsalon = ValideNom( $newsalon);

    if ($newlogin) {
        // Vrifie que le login n'est pas interdit
        $found = false;
        $logintest = strtoupper( $newlogin);
        foreach( $pseudos_interdits as $valeur) {
            if (strtoupper($valeur) == $logintest) $found = true;
        }

        if ($found == false) {
            if (!defined("BASE_UTILISATEURS_EXTERNE") or (BASE_UTILISATEURS_EXTERNE == false)) {
                // Verification du login/pwd (mode normal)
                $requete = mysql_query( "SELECT id,login,mdp,DECODE(mdp_encoded,'" . PASS_MYSQL . "') as mdp2,nom,prenom,email,priv FROM $table_base_utilisateur WHERE login='$newlogin'", $chat_base);
                if ($requete) {
                    if (mysql_Num_Rows( $requete) == 1) {
                        $id = mysql_result( $requete, 0, "id");
                        $goodmdp1 = Decrypte( mysql_result( $requete, 0, "mdp"));
                        $goodmdp2 = Decrypte( mysql_result( $requete, 0, "mdp2"));
                        if (($goodmdp1 == $newmdp) or ($goodmdp2 == $newmdp)) {
                            $newpriv = mysql_result( $requete, 0, "priv");
                            // Met a jour ses donnees de connexion
                            $requete_maj = mysql_query( "UPDATE $table_base_utilisateur SET nb_cnx_chat=nb_cnx_chat+1,date_cnx='" . date( 'Y-m-d H:i:s') . "',last_ip='$remote_addr',last_browser='" . $_SERVER['HTTP_USER_AGENT'] . "' WHERE id=$id LIMIT 1", $chat_base);
                        } else {
                            Header( "Location: " . PageErreur( "lang=$lang&erreur=" . urlencode( $langue_erreur["mdp"])));
                            exit;
                        }
                    } elseif ((mysql_Num_Rows( $requete) == 0) and ($newmdp == '')) {
                        // Utilisateur inconnu
                        if (!defined("ENREGISTREMENT_OBLIGATOIRE") or (ENREGISTREMENT_OBLIGATOIRE == false)) {
                            // Peut se connecter...
                            $newpriv = PRIV_NON_ENREGISTRE;
                        } else {
                            Header( "Location: " . PageErreur( "lang=$lang&erreur=" . urlencode( $langue_erreur["inconnu"])));
                            exit;
                        }
                    }
                } else {
                    Header( "Location: " . PageErreur( "lang=$lang&erreur=" . urlencode( $langue_erreur["base"])));
                    exit;
                }
            } else {
                // Mode externe
                $newpriv = ConnexionUtilisateurExterne( $newlogin, $newmdp);
                if ($newpriv == EXT_UTILISATEUR_INCONNU) {
                    Header( "Location: " . PageErreur( "lang=$lang&erreur=" . urlencode( $langue_erreur["inconnu"])));
                    exit;
                } elseif ($newpriv == EXT_ERREUR_AUTHENTIFICATION) {
                    Header( "Location: " . PageErreur( "lang=$lang&erreur=" . urlencode( $langue_erreur["user_mdp"])));
                    exit;
                }
            }
            // Test si le chat est actif
            if (LireMeta( 'chat_actif', 'oui') == 'non') {
                // Inactif => seul un admin peut se connecter
                if ($newpriv < PRIV_ADMINISTRATEUR) {
                    Header( "Location: " . PageErreur( "lang=$lang&erreur=" . urlencode( $langue_erreur["inactif"])));
                    exit;
                }
            }
        } else {
            Header( "Location: " . PageErreur( "lang=$lang&erreur=" . urlencode( $langue_erreur["interdit"])));
            exit;
        }
    } else {
        Header( "Location: " . PageErreur( "lang=$lang&erreur=" . urlencode( $langue_erreur["pseudo"])));
        exit;
    }

    include( "inc/login.php");

    chat_close();
?>