<?php

//*************************************************************
//
// Mise en forme HTML des messages pour le CHAT
//
// Projet      : Chaton
// Version     : 1.5.1
// Date        : 24 Juin 2005
//
//*************************************************************

// Vous pouvez vous-mme dfinir vos smilies
if (file_exists( TEMPLATE_DIR . TEMPLATE . '/smilies.php')) {
    include_once( TEMPLATE_DIR . TEMPLATE . '/smilies.php');
}

// Tableau des smilies par dfaut
if (!isset( $table_smilies)) {
    $table_smilies = array (
        ":)" => "icon_smile.gif",
        ":-)" => "icon_smile.gif",
    
        " ;)" => "icon_wink.gif",
        ";-)" => "icon_wink.gif",
    
        ":(" => "icon_sad.gif",
        ":-(" => "icon_sad.gif",
    
        " :/" => "icon_confused.gif",
        ":-/" => "icon_confused.gif",
    
        ":|" => "icon_neutral.gif",
        ":-|" => "icon_neutral.gif",
    
        ":D" => "icon_biggrin.gif",
        ":-D" => "icon_biggrin.gif",
    
        ":p" => "icon_razz.gif",
        ":-p" => "icon_razz.gif",
    
        ":o" => "icon_surprised.gif",
        ":-o" => "icon_surprised.gif",
    
        ":$" => "icon_redface.gif",
        ":-$" => "icon_redface.gif",
    
        ":&#039;(" => "icon_cry.gif",
        ":&#039;-(" => "icon_cry.gif",
    
        ":s" => "icon_eh.gif",
        ":-s" => "icon_eh.gif",
    
        ":k" => "icon_think.gif",
        ":-k" => "icon_think.gif",
    
        ":^o" => "icon_liar.gif",
        ":---)" => "icon_liar.gif",
    
        ":#" => "icon_silenced.gif",
        ":-#" => "icon_silenced.gif",
    
        "[-(" => "icon_snooty.gif",
    
        ":-&quot;" => "icon_whistle.gif",
    
        "8-)" => "icon_cool.gif",
    
        "8-|" => "icon_eek.gif",
    
        "#-o" => "icon_doh.gif",
    
        "=D&gt;" => "icon_clap.gif",
    
        "[-X" => "icon_naughty.gif",
    
        "[-o&lt;" => "icon_pray.gif",
    
        "8-]" => "icon_shifty.gif",
    
        ":!" => "icon_exclaim.gif",
        ":?" => "icon_question.gif",
    
        ":-*" => "smack.png",
    );
}


//*************************************************************
// Fonction html_entity_decode pour PHP < 4.3.0
//*************************************************************

    if (!function_exists('html_entity_decode')) {

        if (!defined("ENT_COMPAT")) define("ENT_COMPAT", 2);
        if (!defined("ENT_NOQUOTES")) define("ENT_NOQUOTES", 0);
        if (!defined("ENT_QUOTES")) define("ENT_QUOTES", 3);

        function html_entity_decode ($string, $opt = ENT_COMPAT, $charset = '') {
            // PHP < 4.3 ne supporte de toute faon pas les tables de caractres,
            // le paramtre charset n'est donc pas utilis

            $trans_tbl = get_html_translation_table (HTML_ENTITIES);
            $trans_tbl = array_flip ($trans_tbl);

            if ($opt & 1) { // Transformer les guillemets simples

                // Ajoute les simples quote  la table
                $trans_tbl["&apos;"] = "'";
            }

            if (!($opt & 2)) { // Ne pas transformer les doubles guillemets

                // Enlve les double quote de la table
                unset($trans_tbl["&quot;"]);
            }

            return strtr ($string, $trans_tbl);
        }
    }

//*************************************************************
// Cette fonction valide un nom (login ou salon)
//*************************************************************

function ValideNom( $nom) {

    $nom = html_entity_decode( $nom, ENT_QUOTES, CHARSET);
    $nom = strip_tags( $nom);
    // Invalide un panel de caractres de ponctuation...
    $nom = strtr( $nom, '"/\&#@%!?`*$^|()[]{}~+=,;:', '                                ');
    $nom = strtr( $nom, "'", ' ');
    $nom = strtr( trim( $nom), " ", "_");
    // Doit comporter TROIS caractres minimum
    if (strlen( $nom)>=3) {
        $nom = htmlentities( $nom, ENT_COMPAT, CHARSET);
    } else {
        $nom = '';
    }

    return $nom;
}


//*************************************************************
// Cette fonction valide un mot de passe
//*************************************************************

function ValideMdp( $chaine) {

    $chaine = html_entity_decode( $chaine, ENT_QUOTES, CHARSET);
    $chaine = trim( strip_tags( $chaine));
    if (strspn( $chaine, 'abcdefghijklmnopqrstuvwxyz0123456789.:&#@%*$!?/=+-ABCDEFGHIJKLMNOPQRSTUVWXYZ') == strlen( $chaine)) {
        return $chaine;
    } else {
        return '';
    }
}


//*************************************************************


function PretraiteLigneMessage( $msg) {
    Global $chat_sid, $chat_priv;

    if ((defined("DETECTION_IMAGES")) and (DETECTION_IMAGES == true)) {
        // Transformation du message : images
        while( preg_match( '/(\{([^}]+)\})/', $msg, $resultats) > 0) {
            $url = parse_url( trim( $resultats[2]));
            if (isset($url['scheme']) and isset($url['host']) and isset($url['path']) and ($url['scheme'] == 'http')) {
                if ((defined( "AUTORISER_IMAGES_ANONYME") and (AUTORISER_IMAGES_ANONYME == true)) or ($chat_priv != PRIV_NON_ENREGISTRE)) {
                    $nomfichier = pathinfo( strtolower( $url['path']));
                    if (isset($nomfichier['extension']) and (($nomfichier["extension"] == 'jpg') or ($nomfichier["extension"] == 'jpeg') or ($nomfichier["extension"] == 'gif') or ($nomfichier["extension"] == 'png'))) {
                        $fichier = @fopen( $resultats[2], 'rb');
                        if ($fichier) {
                            // Sauver le fichier tlcharg
                            $nomfichier_image = "user_img/$chat_sid/" . date('ymdHis') . '_' . $nomfichier['basename'];
                            $nomfichier_image = str_replace( ' ', '_', $nomfichier_image);
                            @mkdir( "user_img/$chat_sid", 0775);
                            $sortie = @fopen( $nomfichier_image, 'wb');
                            if ($sortie) {
                                while (!feof($fichier)) {
                                    $bin = fread($fichier, 1024);
                                    fwrite($sortie, $bin);
                                }
                                fclose($sortie);
                                fclose($fichier);
                                $imagesize = getimagesize( $nomfichier_image);
                                // Type GIF, JPG ou PNG
                                if (($imagesize) and ($imagesize[2] > 0) and ($imagesize[2] <= 3) and ($imagesize[0] <= MAX_IMAGE_WIDTH) and ($imagesize[1] <= MAX_IMAGE_HEIGHT)) {
                                    // Remplace entre crochets
                                    $msg = str_replace( $resultats[1], "<img src=\"" . URL_SERVEUR . "$nomfichier_image\" {$imagesize[3]}>", $msg);
                                } else {
                                    // Image d'erreur entre crochets
                                    $msg = str_replace( $resultats[1], "<img src='img/e-404.gif' alt='oversized'>", $msg);
                                }
                            } else {
                                // Image d'erreur entre crochets
                                $msg = str_replace( $resultats[1], "<img src='img/e-404.gif' alt='not found #3'>", $msg);
                            }
                        } else {
                            // Image d'erreur entre crochets
                            $msg = str_replace( $resultats[1], "<img src='img/e-404.gif' alt='not found #2'>", $msg);
                        }
                    } else {
                        // Image d'erreur entre crochets
                        $msg = str_replace( $resultats[1], "<img src='img/e-404.gif' alt='not found #1'>", $msg);
                    }
                } else {
                    // Non autoris
                    $msg = str_replace( $resultats[1], "<img src='img/interdit.png'>", $msg);
                }
            } else {
                // Vide entre crochets
                $msg = str_replace( $resultats[1], '', $msg);
            }
        }
    }

    return( $msg);
}

function TraiteLigneMessage( $msg) {
    Global $table_smilies;

    // Transformation du message : smilies
    foreach( $table_smilies as $smiley => $image) {
        $msg = str_replace( $smiley, "<img src='smilies/$image' alt='$smiley'>", $msg);
    }

    if ((defined("DETECTION_HYPERLIENS")) and (DETECTION_HYPERLIENS == true)) {
        // Transformation du message : liens hypertexte
        $msg = preg_replace('`(?<!=|=\'|=")(http(?:s)?://)([/\w\-\.\?\&\=\#]*)`i', '<a href="\\1\\2" target="_blank">\\1\\2</a>', $msg);
    }

    return( $msg);
}

?>