<?php

//*************************************************************
//
// Gestionnaire des salons de CHAT
//
//  Traduction : Manque des messages d'erreurs peu courants
//
// Projet      : Chaton
// Version     : 1.6.3
// Date        : 8 avril 2007
//
//*************************************************************

    require_once( "inc/html.php");
    require_once( "inc/mysql.php");
    require_once( "inc/verrouillage.php");

    if (!defined('CL_NOIR')) define( 'CL_NOIR', 0);
    if (!defined('CL_BLANC')) define( 'CL_BLANC', 16777215);
    define( 'SERVICE_USER', '*');

    // Date des messages
    // date PHP :   $date_message = "'" . date( 'H:i:s') . "'";
    // date MySQL : $date_message = 'now()';
    $date_message = 'now()';

//*************************************************************
// Renvoi le nom complet d'un salon s'il est public
//*************************************************************

function NomSalonPublic( $nom) {
    global $salon_public;

    if (defined( "AUTORISER_PLUSIEURS_SALONS") and (AUTORISER_PLUSIEURS_SALONS == true)) {
        if (isset($salon_public[strtolower($nom)])) {
            return $salon_public[strtolower($nom)];
        } else {
            // Salon priv
            return '';
        }
    } else {
        return $nom;
    }
}


//*************************************************************
//  Ajoute un salon
//
//  Valeurs de retour :
//      > 0 = Identifiant du salon
//      -1  = Donnees incompletes
//      -2  = Erreur de base de donnees
//      -3  = Mot de passe incorrect
//      -4  = Salon plein !
//      -5  = Salon privs non autoris
//*************************************************************

Function AjouteSalon( $salon, $uid, $prive = false, $mdp = '') {
    Global $chat_base, $table_salle;

    if (($uid) and ($salon)) {
        $salon = mysql_real_escape_string( $salon, $chat_base);
        $requete = mysql_query( "SELECT id,mdp,nombre,max FROM $table_salle WHERE nom='$salon'", $chat_base);
        if ($requete) {
            if (mysql_num_rows( $requete) == 1) {
                // La salle existe deja
                $sid = mysql_result( $requete, 0, "id");
                $smdp = mysql_result( $requete, 0, "mdp");
                $nombre = mysql_result( $requete, 0, "nombre");
                $max = mysql_result( $requete, 0, "max");
                if ($nombre < $max) {
                    if ($mdp == $smdp) {
                        $requete = mysql_query( "UPDATE $table_salle SET nombre=nombre+1,version=version+1 WHERE id='$sid' LIMIT 1", $chat_base);
                        return( array( $sid, 0));
                    } else {
                        return( array( -3, 0));
                    }
                } else {
                    return( array( -4, 0));
                }
            } else {
                // Aller, on l'ajoute va !
                if ( ($prive == false) or (defined( "AUTORISER_SALONS_PRIVES") and (AUTORISER_SALONS_PRIVES == true)) ) {
                    $sid_valide = false;
                    while( !$sid_valide) {
                        // Numero de salon aleatoire
                        srand((double)microtime()*1000000);
                        $sid = rand( 1, 65000);

                        // Verifie que le numero est valide
                        $requete = mysql_query( "SELECT id FROM $table_salle WHERE id='$sid'", $chat_base);
                        if ($requete) {
                            if (mysql_num_rows( $requete) == 0) {
                                $sid_valide = true;
                            }
                        } else {
                            // Erreur ?
                            return( array( -2, 0));
                        }
                    }
                    $requete = mysql_query( "INSERT INTO $table_salle (id,nom,createur,nombre,prive,mdp,max) VALUES('$sid','$salon','$uid','1','$prive','$mdp','" . MAX_SALON . "') ", $chat_base);
                    if (($requete) and (mysql_affected_rows($chat_base)==1)) {
                        $chaine_create = "CREATE TABLE salle_$sid (mid int(10) unsigned NOT NULL auto_increment,couleur MEDIUMINT UNSIGNED,msg TEXT NOT NULL default '',de varchar(50) NOT NULL default '',dit varchar(200) NOT NULL default '',a varchar(50) NOT NULL default '',prive tinyint(3) unsigned NOT NULL default '0',heure time default NULL,PRIMARY KEY (mid)";
                        if (defined( "ANTI_FLOODING") and (ANTI_FLOODING == true)) $chaine_create .= ",KEY de (de)";
                        $chaine_create .= ") TYPE=MyISAM;";
                        $requete = mysql_query( $chaine_create, $chat_base);
                        return( array( $sid, $uid));
                    } else {
                        // Erreur ?
                        return( array( -2, 0));
                    }
                } else {
                    // Salon priv interdit
                    return( array( -5, 0));
                }
            }
        } else {
            // Erreur ?
            return( array( -2, 0));
        }
    } else {
        // Donnees incompletes
        return( array( -1, 0));
    }
}


//*************************************************************
//  Enleve un utilisateur du salon
//*************************************************************

Function EnleveSalon( $sid) {
    Global $chat_base, $table_salle;

    if ($sid) {
        $requete = mysql_query( "SELECT (nombre+nb_hide-1) as nombre,permanent FROM $table_salle WHERE id='$sid'", $chat_base);
        if ($requete) {
            if (mysql_num_rows( $requete) == 1) {
                if (mysql_result( $requete, 0, "nombre") <= 0) {
                    // Il n'y a plus personne
                    if (mysql_result( $requete, 0, "permanent") == false) {
                        $requete = mysql_query( "DELETE FROM $table_salle WHERE id='$sid'", $chat_base);
                        if (!defined( "ARCHIVER_DISCUSSIONS") or (ARCHIVER_DISCUSSIONS == false)) {
                            $requete = mysql_query( "DROP TABLE salle_$sid", $chat_base);

                            // Supprime le dossier des images
                            $dh = @opendir( "user_img/$sid");
                            if ($dh) {
                                while ($file = readdir($dh)) {
                                    if($file!="." && $file!="..") @unlink("user_img/$sid/$file");
                                }
                                closedir( $dh);
                                @rmdir( "user_img/$sid");
                            }

                        } else {
                            // Archive la salle !
                            $requete = mysql_query( "ALTER TABLE salle_$sid RENAME `archive_" . date( 'ymdHi') . "_" . $sid . "`", $chat_base);
                        }
                    } else {
                        // Salon permanent, on rinitialise la version
                        $requete = mysql_query( "UPDATE $table_salle SET nombre=nombre-1,version=0 WHERE id='$sid' LIMIT 1", $chat_base);
                    }
                } else {
                    // Il reste encore du monde !
                    $requete = mysql_query( "UPDATE $table_salle SET nombre=nombre-1,version=version+1 WHERE id='$sid' LIMIT 1", $chat_base);
                }
            }
        }
    }
}

//*************************************************************
//  Retourne l'identifiant d'un salon
//*************************************************************

Function idSalon( $nom_salon) {
    Global $chat_base, $table_salle;

    $nom_salon = mysql_real_escape_string( $nom_salon, $chat_base);
    $requete = mysql_query( "SELECT id FROM $table_salle WHERE nom='$nom_salon'", $chat_base);
    if ($requete) {
        if (mysql_num_rows( $requete) == 1 ) {
            return( mysql_result( $requete, 0, "id"));
        } else {
            return( 0);
        }
    }
}


//*************************************************************
//  Indique si la salle courante est prive
//*************************************************************

Function isPrivateRoom( $sid) {
    Global $chat_base, $table_salle;

    $requete = mysql_query( "SELECT prive FROM $table_salle WHERE id='$sid'", $chat_base);
    if ($requete) {
        if (mysql_num_rows( $requete) == 1 ) {
            return( mysql_result( $requete, 0, "prive"));
        } else {
            return( 0);
        }
    }
}


//*************************************************************
//  Change le mot de passe du salon
//  (uniquement pour les salons PRIVES)
//*************************************************************

Function ChangeMdpSalon( $sid, $mdp) {
    Global $chat_base, $table_salle;

    if ($sid) {
        $mdp = mysql_real_escape_string( $mdp, $chat_base);
        $requete = mysql_query( "UPDATE $table_salle SET mdp='$mdp',version=version+1 WHERE id='$sid' AND prive='1' LIMIT 1", $chat_base);
        if ($requete) {
            return (mysql_affected_rows($chat_base) == 1);
        } else {
            return false;
        }
    } else {
        return false;
    }
}


//*************************************************************
//  Change le nombre maximal de connects dans un salon
//*************************************************************

Function ChangeMaxSalon( $sid, $max) {
    Global $chat_base, $table_salle;

    if (($sid) and (is_numeric( $max))) {
        $requete = mysql_query( "UPDATE $table_salle SET max='$max',version=version+1 WHERE id='$sid' LIMIT 1", $chat_base);
        if ($requete) {
            return (mysql_affected_rows($chat_base) == 1);
        } else {
            return false;
        }
    } else {
        return false;
    }
}


//*************************************************************
//  Rend le salon permanent ou non permanent
//*************************************************************

Function ChangePermanent( $sid, $permanent) {
    Global $chat_base, $table_salle;

    if (($sid) and (is_bool( $permanent))) {
        if ($permanent == true) {
            $requete = mysql_query( "UPDATE $table_salle SET permanent=1,version=version+1 WHERE id='$sid' LIMIT 1", $chat_base);
        } elseif ($permanent == false) {
            $requete = mysql_query( "UPDATE $table_salle SET permanent=0,version=version+1 WHERE id='$sid' LIMIT 1", $chat_base);
        }
        if ($requete) {
            return (mysql_affected_rows($chat_base) == 1);
        } else {
            return false;
        }
    } else {
        return false;
    }
}


//*************************************************************
//  Ajoute un message dans la discussion
//*************************************************************

Function NouveauMessage( $uid, $sid, $expediteur, $dit, $to, $message, $prive, $couleur) {
    Global $chat_base, $date_message;

    $ok = true;
    if (($uid) and ($sid) and ($expediteur) and ($dit) and ($to) and ($message != '')) {
        if (defined( "ANTI_FLOODING") and (ANTI_FLOODING == true)) {
            // Verifie les anciens messages posts...
            $requete = mysql_query( "SELECT count(mid) FROM salle_$sid WHERE (time_to_sec( heure) + 10 >= time_to_sec(now())) AND (time_to_sec( heure) <= time_to_sec(now())) AND de='$expediteur'", $chat_base);
            if ($requete) {
                $nb_messages = mysql_result( $requete, 0, 0);
                // debug_journal( "Anti-flood : $nb_messages message(s) pour $expediteur");
                // Limite de 3 messages toutes les 10 secondes
                if ($nb_messages > 3) $ok = false;
            }
        }
        if ($ok) {
            $expediteur = mysql_real_escape_string( $expediteur, $chat_base);
            $dit = mysql_real_escape_string( $dit, $chat_base);
            $to = mysql_real_escape_string( $to, $chat_base);
            $message = mysql_real_escape_string( $message, $chat_base);
            if (is_null( $couleur)) {
                $requete = mysql_query( "INSERT INTO salle_$sid (msg,de,dit,a,prive,heure,couleur) VALUES( '$message', '$expediteur', '$dit', '$to', '$prive', $date_message,NULL)", $chat_base);
            } else {
                $requete = mysql_query( "INSERT INTO salle_$sid (msg,de,dit,a,prive,heure,couleur) VALUES( '$message', '$expediteur', '$dit', '$to', '$prive', $date_message,'$couleur')", $chat_base);
            }
        }
    }
    return $ok;
}

//*************************************************************
//  Entree / Sortie d'un utilisateur
//*************************************************************

Function EntreeSortie( $sid, $loginchat, $message) {
    Global $chat_base, $date_message;

    if (($sid) and ($loginchat) and ($message)) {
        $loginchat = mysql_real_escape_string( $loginchat, $chat_base);
        $message = mysql_real_escape_string( $message, $chat_base);
        $requete = mysql_query( "INSERT INTO salle_$sid (msg,de,dit,a,prive,heure) VALUES( '', '$loginchat', '$message', '', '0', $date_message)", $chat_base);
    }
}

//*************************************************************
//  Ajoute une annonce publique
//*************************************************************

Function AnnoncePublique( $sid, $message) {
    Global $chat_base, $date_message;

    if (($sid) and ($message)) {
        $message = mysql_real_escape_string( $message, $chat_base);
        $requete = mysql_query( "INSERT INTO salle_$sid (msg,de,dit,a,prive,heure) VALUES( '', '', '$message', '', '0', $date_message)", $chat_base);
    }
}


//*************************************************************
//  Ajoute une annonce privee
//*************************************************************

Function AnnoncePrivee( $sid, $destinataire, $message) {
    Global $chat_base, $date_message;

    if (($sid) and ($destinataire) and ($message)) {
        $destinataire = mysql_real_escape_string( $destinataire, $chat_base);
        $message = mysql_real_escape_string( $message, $chat_base);
        $requete = mysql_query( "INSERT INTO salle_$sid (msg,de,dit,a,prive,heure) VALUES( '$message', '" . SERVICE_USER . "', '<msg#annonce>', '$destinataire', '1', $date_message)", $chat_base);
    }
}


//*************************************************************
//  Ajoute une annonce privee avec un appel
//*************************************************************

Function AppelPrive( $sid, $destinataire, $message) {
    Global $chat_base, $date_message;

    if (($sid) and ($destinataire) and ($message)) {
        $destinataire = mysql_real_escape_string( $destinataire, $chat_base);
        $message = mysql_real_escape_string( $message, $chat_base);
        $requete = mysql_query( "INSERT INTO salle_$sid (msg,de,dit,a,prive,heure) VALUES( '$message', '" . SERVICE_USER . "', '<msg#annonce>', '$destinataire', '2', $date_message)", $chat_base);
    }
}


//*************************************************************
//  Construit la ligne de message  afficher
//
//  Cette fonction n'est probablement pas trs optimise,
//  mais elle n'est lance que sur les messages de service !
//*************************************************************

function TraiteLangueMessage( $msg, $lang) {
    Global $langue_chat;

    $msg = trim( $msg);

    // Transformation des messages
    $msg = str_replace( "<msg#rentre>", $langue_chat["rentre"], $msg);
    $msg = str_replace( "<msg#rentre_defaut>", $langue_chat["rentre_defaut"], $msg);
    $msg = str_replace( "<msg#quitte>", $langue_chat["quitte"], $msg);
    $msg = str_replace( "<msg#quitte_defaut>", $langue_chat["quitte_defaut"], $msg);
    $msg = str_replace( "<msg#ferme>", $langue_chat["ferme"], $msg);
    $msg = str_replace( "<msg#ferme_defaut>", $langue_chat["ferme_defaut"], $msg);
    $msg = str_replace( "<msg#retour>", $langue_chat["retour"], $msg);
    $msg = str_replace( "<msg#frappe>", $langue_chat["frappe"], $msg);
    $msg = str_replace( "<msg#proprio>", $langue_chat["proprio"], $msg);
    $msg = str_replace( "<msg#absent>", $langue_chat["absent"], $msg);
    $msg = str_replace( "<msg#deplace>", $langue_chat["deplace"], $msg);
    $msg = str_replace( "<msg#annonce>", $langue_chat["annonce"], $msg);
    $msg = str_replace( "<msg#eject>", $langue_chat["eject"], $msg);
    $msg = str_replace( "<msg#oqp_msg>", $langue_chat["oqp_msg"], $msg);
    $msg = str_replace( "<msg#oqp>", $langue_chat["oqp"], $msg);
    $msg = str_replace( "<msg#invite>", $langue_chat["invite"], $msg);
    $msg = str_replace( "<msg#invite_inconnu>", $langue_chat["invite_inconnu"], $msg);
    $msg = str_replace( "<msg#invite_impossible>", $langue_chat["invite_impossible"], $msg);
    $msg = str_replace( "<msg#invitation>", $langue_chat["invitation"], $msg);
    $msg = str_replace( "<msg#appel>", $langue_chat["appel"], $msg);
    $msg = str_replace( "<msg#appeler>", $langue_chat["appeler"], $msg);
    $msg = str_replace( "<msg#appel_inconnu>", $langue_chat["appel_inconnu"], $msg);
    $msg = str_replace( "<msg#appel_impossible>", $langue_chat["appel_impossible"], $msg);
    $msg = str_replace( "<msg#change_max>", $langue_chat["change_max"], $msg);
    $msg = str_replace( "<msg#permanent>", $langue_chat["permanent"], $msg);
    $msg = str_replace( "<msg#non_permanent>", $langue_chat["non_permanent"], $msg);
    $msg = str_replace( "<msg#change_proprio>", $langue_chat["change_proprio"], $msg);
    $msg = str_replace( "<msg#erreur_change_proprio>", $langue_chat["erreur_change_proprio"], $msg);
    $msg = str_replace( "<msg#change_channel_pwd>", $langue_chat["change_channel_pwd"], $msg);
    $msg = str_replace( "<msg#delete_channel_pwd>", $langue_chat["delete_channel_pwd"], $msg);

    return( $msg);
}

Function ConstruitLigneDiscussion( $loginchat, $heure, $de, $dit, $pseudo, $msg, $couleur, $prive, $chat_lang) {
    Global $chat_appel, $langue_chat;

    $chaine = '';

    // Taille par defaut des caracteres
    if ( (strncasecmp( $dit, "crie", 4) == 0) or (strncasecmp( $dit, "shouts", 6) == 0) ) {
        $taille = "_crie";
    } else if ( strncasecmp( $dit, "murmur", 6) == 0) {
        $taille = "_murmure";
    } else {
        $taille = "";
    }

    if ($pseudo) {

        if ($de == SERVICE_USER) {
            // Message de service priv (en gnral un message d'erreur)
            if (strcasecmp( $pseudo, $loginchat) == 0) {
                $dit = TraiteLangueMessage( $dit, $chat_lang);
                $msg = TraiteLangueMessage( $msg, $chat_lang);

                // Message de service
                // $chaine .= addslashes( "<font class=\"chat_service_prive\"><i>$heure</i> - <b> " . ANNOUNCE_USER . " $dit $pseudo : </b>$msg</font><br>");
                $chaine .= addslashes( "<font class=\"chat_service_prive\"><i>$heure</i> - $msg</font><br>");

                // Appel
                if ($prive == 2) $chat_appel = true;
            }
        } else {
            // Traitement html du message
            $msg = TraiteLigneMessage( $msg);

            // Couleur du message
            if ((!is_null($couleur)) and ($couleur >= CL_NOIR) and ($couleur <= CL_BLANC)) {
                $msg = sprintf( '<font color="#%06s">', dechex( $couleur)) . $msg . '</font>';
            }

            // Message d'un utilisateur
            if ($prive > 0) {
                // Message prive
                if ((strcasecmp( $de, $loginchat) == 0) or (strcasecmp( $pseudo, $loginchat) == 0)) {
                    $chaine .= addslashes( "<font class=\"chat_prive\"");
                    $chaine .= addslashes( "><i>$heure</i> - <b> $de $dit $pseudo (" . $langue_chat["prive"] . ") : </b>");
                    if ($taille <> "") {
                        $chaine .= addslashes( "</font><font class=\"chat_prive$taille\"");
                        $chaine .= ">";
                    }
                    $chaine .= addslashes( "$msg</font><br>");
                    // Appel /!\ Ne doit en thorie plus passer par l
                    if ($prive == 2) $chat_appel = true;
                }
            } else  {
                // Message public
                if (strcasecmp( $pseudo, $loginchat) == 0) {
                    // Message destinataire
                    $style = "chat_dest";
                } elseif (strcasecmp( $de, $loginchat) == 0) {
                    // Message expditeur
                    $style = "chat_exp";
                } else {
                    $style = "chat";
                }

                $chaine .= addslashes( "<font class=\"$style\"");
                $chaine .= addslashes( "><i>$heure</i> - <b>$de $dit $pseudo</b> : ");
                if ($taille <> "") {
                    $chaine .= addslashes( "</font><font class=\"$style$taille\"");
                    $chaine .= ">";
                }
                $chaine .= addslashes( "$msg</font><br>");
            }
        }
    } else {
        // Traitement de la langue du message de service
        $dit = TraiteLangueMessage( $dit, $chat_lang);

        // Message de service
        $chaine .= addslashes( "<font class=\"chat_service\"><i>$heure</i> - <b> $de $dit</b></font><br>");
    }

    return $chaine;
}

//*************************************************************
//  Ecrit les derniers messages de la discussion en cours
//*************************************************************

Function Discussion( $uid, $loginchat, $sid, $gap = 0) {
    Global $chat_lang, $chat_numeromsg, $chat_base, $table_utilisateur, $langue_chat;

    // Charge le module de langue associ au script courant
    if (file_exists( "lang/$chat_lang/salons.php")) {
        include( "lang/$chat_lang/salons.php");
    }
    if (file_exists( "lang/$chat_lang/dit.php")) {
        include( "lang/$chat_lang/dit.php");
    }

    $chaine = "";
    if ($sid) {
        if (VerrouillerChat( $uid, $sid)) {
            $requete = mysql_query( "SELECT @numero:=(numero+$gap) FROM $table_utilisateur WHERE id=$uid", $chat_base);
            if ($requete) {
                $chat_numeromsg = mysql_result( $requete, 0, 0);
                // Charge les messages
                $requete = mysql_query( "SELECT mid,couleur,msg,de,dit,a,prive,heure FROM salle_$sid WHERE (mid>=@numero) ORDER BY mid", $chat_base);
                if ($requete) {
                    if (mysql_num_rows( $requete) > 0) {
                        // Dboggage
                        debug_journal( "debut: uid = $uid, numero_msg = $chat_numeromsg");
                        while ($row = mysql_fetch_array( $requete)) {
                            $chat_numeromsg = $row["mid"] + 1;

                            if ((is_numeric($row['dit'])) and (isset($langue_dit[$row['dit']-1]))) {
                                $chaine_dit = $langue_dit[$row['dit']-1];
                            } else {
                                $chaine_dit = $row['dit'];
                            }
                            $chaine .= ConstruitLigneDiscussion( $loginchat, $row['heure'], $row['de'], $chaine_dit, $row['a'], $row['msg'], $row['couleur'], $row['prive'], $chat_lang);
                        } // while
                        // Met  jour le dernier numro de message
                        $requete_update = mysql_query( "UPDATE $table_utilisateur SET enr=now(), numero='$chat_numeromsg' WHERE id='$uid' LIMIT 1", $chat_base);
                        // Dboggage
                        debug_journal( "  fin: uid = $uid, numero_msg = $chat_numeromsg");
                    } else {
                        // Met  jour la date de poll
                        $requete_update = mysql_query( "UPDATE $table_utilisateur SET enr=now() WHERE id='$uid' LIMIT 1", $chat_base);
                    }
                    mysql_free_result( $requete);
                } else {
                    $chaine = "<b>Erreur:</b> Impossible de lire dans le salon: " . mysql_error() . "<br>";
                }
            } else {
                $chaine = "<b>Erreur:</b> Impossible de lire la table utilisateurs: " . mysql_error() . "<br>";
            }
            DeverrouillerChat( $uid, $sid);
        } else {
            // Dboggage
            debug_journal( "Warning: Verrou chaton_" . $uid . "_" . $sid . " actif");
        }   // Verrou
    }
    return $chaine;
}


//*************************************************************
//  Recherche le nombre de connexions par salle
//*************************************************************

Function NombreConnectesParSalle( $prive = false) {
    Global $chat_base, $table_salle;

    if ($prive) {
        $prive = 1;
    } else {
        $prive = 0;
    }

    $requete = mysql_query( "SELECT nom,nombre FROM $table_salle WHERE prive=$prive ORDER BY nom", $chat_base);
    if ($requete) {
        if (mysql_num_rows( $requete) > 0) {
            for( $i=0; $i<mysql_num_rows( $requete); $i++) {
                $nom_interne = mysql_result( $requete, $i, "nom");
                $nom_salle = StripSlashes( $nom_interne);
                $nombre = mysql_result( $requete, $i, "nombre");
                if ($nombre > 1) $pluriel = 's';
                $table_salons[$nom_interne] = $nombre;
            }
        }
    }

    if (isset($table_salons)) {
        return $table_salons;
    } else {
        return null;
    }
}

?>
