<?php
//*************************************************************
//
// Page d'entre du Chat - affichage du formulaire
//
// Projet      : Chaton
// Version     : 1.6.1
// Date        : 8 novembre 2006
//
//*************************************************************

    // *** PERSONNALISATION : Voici les fonctions que vous pouvez utiliser pour construire votre page d'accueil ***
    // IndexAfficheSalonsPublics( avec_presents)
    // IndexAfficheSalonsPrives( avec_presents)

    // *** AFFICHAGE DE LA LISTE DES SALONS PUBLICS ***
    function IndexAfficheSalonsPublics( $avec_presents = true) {
        Global $salon_public, $salon_par_defaut;

        // Recherche le nombre de connexions par salon public
        $table_salons = NombreConnectesParSalle( false);

        // Affichage des salons publics
        foreach( $salon_public as $nom_interne => $nom_salle) {
            // Bouton de choix du salon
            echo( "<input type=\"radio\" name=\"newsalon\" id=\"public_$nom_interne\" value=\"$nom_interne\"");
            if (isset($table_salons[$nom_interne])) {
                // Salon par defaut = premier salon avec un utilisateur
                if (!$salon_par_defaut) {
                    $salon_par_defaut = true;
                    echo( " checked");
                }
                if ($avec_presents) {
                    // Affichage du nom du salon avec des connects dans le salon
                    echo( "><a href=\"\" OnClick=\"javascript: AffichePresents('$nom_interne'); return(false);\">$nom_salle (" . $table_salons[$nom_interne] . ")</a>\n");
                } else {
                    // Affichage du nom du salon
                    echo( "><label for=\"public_$nom_interne\">$nom_salle (" . $table_salons[$nom_interne] . ")</label>\n");
                }
            } else {
                // Salon par defaut = premier salon si aucun utilisateur
                if ((!$salon_par_defaut) and (count($table_salons)==0)) {
                    $salon_par_defaut = true;
                    echo( " checked");
                }
                // Affichage du nom du salon
                echo( "><label for=\"public_$nom_interne\">$nom_salle</label>");
            }
            // Passe au salon suivant
            echo( "<br>\n");
        }
    }

    // *** AFFICHAGE DE LA LISTE DES SALONS PRIVES ***
    function IndexAfficheSalonsPrives( $avec_presents = true) {
        Global $langue_index;

        // Recherche le nombre de connexions par salon priv
        $table_salons = NombreConnectesParSalle( true);

        if ($table_salons) {
            // Affichage des salons privs
            foreach( $table_salons as $nom_interne => $nombre) {
                $nom_salle = StripSlashes( $nom_interne);
                echo( "<input type=\"radio\" name=\"newsalon\" id=\"prive_$nom_interne\" value=\"$nom_interne\"");
                if ($nombre > 0) {
                    if ($avec_presents) {
                        // Affichage du nom du salon avec des connects dans le salon
                        echo( "><a href=\"\" OnClick=\"javascript: AffichePresents('$nom_interne'); return(false);\">$nom_salle ($nombre)</a>");
                    } else {
                        // Affichage du nom du salon
                        echo( "><label for=\"prive_$nom_interne\">$nom_salle ($nombre)</label>");
                    }
                } else {
                    // Affichage du nom du salon
                    echo( "><label for=\"prive_$nom_interne\">$nom_salle ($nombre)</label>");
                }
                // Passe au salon suivant
                echo( "<br>\n");
            }
        }
        echo( "<input type=\"radio\" name=\"newsalon\" id=\"newsalon\" value=\"\"><label for=\"newsalon\">{$langue_index['nouveau_salon']}</label>");
    }

    // Tests de l'installation
    if (phpversion() < '4.1.0') {
        echo( "Vous devez disposer d'une version de PHP gale ou suprieure  la 4.1.0");
        exit();
    }

    if (!file_exists( "inc/chat.php") or !file_exists( "inc/database.php") or !file_exists( "inc/externe.php")) {
        echo( "<html>Vous devez lancer le script <a href=install.php>install.php</a> avant de dmarrer.</html>");
        exit;
    }

    // Inclus specifiques au chat
    require_once( "inc/chat.php");
    require_once( "inc/securite.php");
    require_once( "inc/session.php");
    require_once( "inc/langue.php");
    require_once( "inc/database.php");
    require_once( "inc/log.php");
    require_once( "inc/users.php");
    require_once( "inc/nocache.php");
    require_once( "inc/menage.php");

    // Test du modle
    if (!file_exists( TEMPLATE_DIR . TEMPLATE . "/config.php")) {
        echo( "<html>Votre modle par dfaut n'existe pas.</html>");
        exit;
    }

    // Vrification du modle
    require_once( TEMPLATE_DIR . TEMPLATE . "/config.php");
    if (TEMPLATE_VERSION > $chat_model['CUR_TEMPLATE_VERSION']) {
        echo( "<html>Votre modle est trop ancien pour fonctionner avec cette version du gestionnaire de modles.</html>");
        exit;
    }

    // Charge le module de langue associ au script courant
    if (file_exists( "lang/$lang/index.php")) {
        include( "lang/$lang/index.php");
    }

    chat_open();

    $salon_par_defaut = false;

    // Base de donnes OK ?
    if ($chat_base) {
        // Supprime ventuellement les utilisateurs qui ont quitt le chat
        Menage( $chat_base, $table_utilisateur);
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<HTML>
<HEAD>
<TITLE><?php echo( NOM_CHAT); ?></TITLE>
<meta http-equiv="Content-Type" content="text/html; charset=<?php echo( CHARSET); ?>">
<link rel="stylesheet" href="<?php echo( TEMPLATE_DIR . TEMPLATE . '/'); ?>css/style.css" type="text/css">
<script type="text/javascript" language="JavaScript">

function AffichePresents( salon) {
    window.open('qui.php?lang=<?php echo( $lang) ?>&salon=' + salon,'qui','toolbar=no,scrollbars=yes,height=450,width=400');
    return( false);
}

function PassPerdu() {
    window.open('pass.php','pass','toolbar=no,scrollbars=yes,height=300,width=400');
    return( false);
}

function VerifForm( formulaire) {
    <?php if (defined("ENREGISTREMENT_OBLIGATOIRE") and (ENREGISTREMENT_OBLIGATOIRE == true)) { ?>
    if (formulaire.newlogin.value == '' || formulaire.newmdp.value == '') {
        alert( '<?php echo( $langue_index['erreur_login_pass']); ?>');
        return( false);
    } else {
        return( true);
    }
    <?php } else { ?>
    if (formulaire.newlogin.value == '') {
        alert( '<?php echo( $langue_index['erreur_login']); ?>');
        return( false);
    } else {
        return( true);
    }
    <?php } ?>
}

</script>
</HEAD>
<?php include( TEMPLATE_DIR . TEMPLATE . '/index.php');
        if (isset( $erreur)) {
?>
<script language="javascript">
  window.alert("<?php echo( $erreur); ?>");
</script>
<?php
        }
?>
</HTML>
<?php
    } else {
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<HTML>
<HEAD>
<TITLE><?php echo( NOM_CHAT); ?></TITLE>
<meta http-equiv="Content-Type" content="text/html; charset=<?php echo( CHARSET); ?>">
<link rel="stylesheet" href="<?php echo( TEMPLATE_DIR . TEMPLATE . '/'); ?>css/style.css" type="text/css">
</head>
<body>
<table border="0" cellspacing="2" cellpadding="2" align="center">
  <tr>
    <td><i><b>Attention :</b></i><br>
      Le serveur de base de donn&eacute;es n'est actuellement pas accessible...<br>
      Veuillez nous excuser...</td>
  </tr>
</table>
</body>
</HTML>
<?php
    }
    chat_close();
?>